
#ifndef __FSOUSAGE_H__
#define __FSOUSAGE_H__

#include <glib.h>
#include <fsoframework.h>
#include <freesmartphone.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define FSO_DEVICE_TYPE_BASE_POWER_CONTROL (fso_device_base_power_control_get_type ())
#define FSO_DEVICE_BASE_POWER_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_DEVICE_TYPE_BASE_POWER_CONTROL, FsoDeviceBasePowerControl))
#define FSO_DEVICE_BASE_POWER_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_DEVICE_TYPE_BASE_POWER_CONTROL, FsoDeviceBasePowerControlClass))
#define FSO_DEVICE_IS_BASE_POWER_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_DEVICE_TYPE_BASE_POWER_CONTROL))
#define FSO_DEVICE_IS_BASE_POWER_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_DEVICE_TYPE_BASE_POWER_CONTROL))
#define FSO_DEVICE_BASE_POWER_CONTROL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_DEVICE_TYPE_BASE_POWER_CONTROL, FsoDeviceBasePowerControlClass))

typedef struct _FsoDeviceBasePowerControl FsoDeviceBasePowerControl;
typedef struct _FsoDeviceBasePowerControlClass FsoDeviceBasePowerControlClass;
typedef struct _FsoDeviceBasePowerControlPrivate FsoDeviceBasePowerControlPrivate;

struct _FsoDeviceBasePowerControl {
	FsoFrameworkAbstractObject parent_instance;
	FsoDeviceBasePowerControlPrivate * priv;
};

struct _FsoDeviceBasePowerControlClass {
	FsoFrameworkAbstractObjectClass parent_class;
	gboolean (*getPower) (FsoDeviceBasePowerControl* self);
	void (*setPower) (FsoDeviceBasePowerControl* self, gboolean on);
};


GType fso_device_base_power_control_get_type (void);
extern guint fso_device_base_power_control_counter;
FsoDeviceBasePowerControl* fso_device_base_power_control_new (const char* powernode, const char* onvalue, const char* offvalue, guint switchtimeout);
FsoDeviceBasePowerControl* fso_device_base_power_control_construct (GType object_type, const char* powernode, const char* onvalue, const char* offvalue, guint switchtimeout);
gboolean fso_device_base_power_control_getPower (FsoDeviceBasePowerControl* self);
void fso_device_base_power_control_setPower (FsoDeviceBasePowerControl* self, gboolean on);


G_END_DECLS

#endif
